// dllmain.cpp
// (c) 2011, Charles Lechasseur
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

#include "stdafx.h"
#include "resource.h"
#include "TestPlugins_i.h"
#include <PathCopyCopy_i.h>
#include "dllmain.h"
#include "dlldatax.h"

CTestPluginsModule _AtlModule;

// Registers our COM object. Let's use the opportunity to register our plugins.
HRESULT CTestPluginsModule::DllRegisterServer( BOOL bRegTypeLib /*= TRUE*/ ) throw()
{
    HRESULT hRes = CAtlDllModuleT< CTestPluginsModule >::DllRegisterServer(bRegTypeLib);
    if (SUCCEEDED(hRes)) {
        CComPtr<IPathCopyCopyContextMenuExt> cpPccExt;
        hRes = cpPccExt.CoCreateInstance(__uuidof(PathCopyCopyContextMenuExt));
        if (SUCCEEDED(hRes)) {
            cpPccExt->RegisterPlugin(__uuidof(PathCopyCopyPlugin1a));
            cpPccExt->RegisterPlugin(__uuidof(PathCopyCopyPlugin1b));
            cpPccExt->RegisterPlugin(__uuidof(PathCopyCopyPlugin2a));
            cpPccExt->RegisterPlugin(__uuidof(PathCopyCopyPlugin2b));
        }
    }
    return hRes;
}

// Unregisters our COM object. We will also remove our plugins from Path Copy Copy.
HRESULT CTestPluginsModule::DllUnregisterServer( BOOL bUnRegTypeLib /*= TRUE*/ ) throw()
{
    HRESULT hRes = CAtlDllModuleT< CTestPluginsModule >::DllUnregisterServer(bUnRegTypeLib);
    if (SUCCEEDED(hRes)) {
        CComPtr<IPathCopyCopyContextMenuExt> cpPccExt;
        hRes = cpPccExt.CoCreateInstance(__uuidof(PathCopyCopyContextMenuExt));
        if (SUCCEEDED(hRes)) {
            cpPccExt->UnregisterPlugin(__uuidof(PathCopyCopyPlugin1a));
            cpPccExt->UnregisterPlugin(__uuidof(PathCopyCopyPlugin1b));
            cpPccExt->UnregisterPlugin(__uuidof(PathCopyCopyPlugin2a));
            cpPccExt->UnregisterPlugin(__uuidof(PathCopyCopyPlugin2b));
        }
    }
    return hRes;
}

// DLL Entry Point
extern "C" BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
#ifdef _MERGE_PROXYSTUB
	if (!PrxDllMain(hInstance, dwReason, lpReserved))
		return FALSE;
#endif
	hInstance;
	return _AtlModule.DllMain(dwReason, lpReserved); 
}
